/***********************************************************************
 *
 * Computer Control Company gates - verilog models 
 * 
 * Copyright (C) 2007, 2011, 2013, 2017 Adrian Wise
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of version 3 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See http://www.series16.adrianwise.co.uk
 *   mailto:apw@adrianwise.co.uk
 * 
 ***********************************************************************/

module ccc_nand1 (op, in1);
   output op;
   input  in1;
   not (strong0, pull1) #16 not1 (op, in1);
endmodule // ccc_nand1

module ccc_nand2 (op, in1, in2);
   output op;
   input  in1, in2;
   nand (strong0, pull1) #16 nand1 (op, in1, in2);
endmodule // ccc_nand1

module ccc_nand2a (op, in1, in2);
   output op;
   input  in1, in2;
   nand (strong0, pull1) #16 nand1 (op, in1, in2);
endmodule // ccc_nand1

module ccc_nand2b (op, in1, in2);
   output op;
   input  in1, in2;
   nand (strong0, pull1) #16 nand1 (op, in1, in2);
endmodule // ccc_nand1

module ccc_nand3 (op, in1, in2, in3);
   output op;
   input  in1, in2, in3;
   nand (strong0, pull1) #16 nand1 (op, in1, in2, in3);
endmodule // ccc_nand1

module ccc_nand4 (op, in1, in2, in3, in4);
   output op;
   input  in1, in2, in3, in4;
   nand (strong0, pull1) #16 nand1 (op, in1, in2, in3, in4);
endmodule // ccc_nand1

module ccc_nand5 (op, in1, in2, in3, in4,
                  in5);
   output op;
   input  in1, in2, in3, in4, in5;
   nand (strong0, pull1) #16 nand1 (op, in1, in2, in3, in4,
                                    in5);
endmodule // ccc_nand1

module ccc_nand6 (op, in1, in2, in3, in4,
                  in5, in6);
   output op;
   input  in1, in2, in3, in4, in5, in6;
   nand (strong0, pull1) #16 nand1 (op, in1, in2, in3, in4,
                                    in5, in6);
endmodule // ccc_nand1

module ccc_nand7 (op, in1, in2, in3, in4,
                  in5, in6, in7);
   output op;
   input  in1, in2, in3, in4, in5, in6, in7;
   nand (strong0, pull1) #16 nand1 (op, in1, in2, in3, in4,
                                    in5, in6, in7);
endmodule // ccc_nand1

module ccc_nand8 (op, in1, in2, in3, in4,
                  in5, in6, in7, in8);
   output op;
   input  in1, in2, in3, in4, in5, in6, in7, in8;
   nand (strong0, pull1) #16 nand1 (op, in1, in2, in3, in4,
                                    in5, in6, in7, in8);
endmodule // ccc_nand8

module ccc_nand9 (op, in1, in2, in3, in4,
                  in5, in6, in7, in8, in9);
   output op;
   input  in1, in2, in3, in4, in5, in6, in7, in8, in9;
   nand (strong0, pull1) #16 nand1 (op, in1, in2, in3, in4,
                                    in5, in6, in7, in8, in9);
endmodule // ccc_nand9

module ccc_nand1n (op, nd, in1);
   output op;
   input  nd, in1;
   nand (strong0, pull1) #16 nand1 (op, nd, in1);
endmodule // ccc_nand1

module ccc_nand2n (op, nd, in1, in2);
   output op;
   input  nd, in1, in2;
   nand (strong0, pull1) #16 nand1 (op, nd, in1, in2);
endmodule // ccc_nand1

module ccc_nand3n (op, nd, in1, in2, in3);
   output op;
   input  nd, in1, in2, in3;
   nand (strong0, pull1) #16 nand1 (op, nd, in1, in2, in3);
endmodule // ccc_nand1

module ccc_nand4n (op, nd, in1, in2, in3,
                   in4);
   output op;
   input  nd, in1, in2, in3, in4;
   nand (strong0, pull1) #16 nand1 (op, nd, in1, in2, in3,
                                    in4);
endmodule // ccc_nand1

module ccc_nand5n (op, nd, in1, in2, in3,
                   in4, in5);
   output op;
   input  nd, in1, in2, in3, in4, in5;
   nand (strong0, pull1) #16 nand1 (op, nd, in1, in2, in3,
                                    in4, in5);
endmodule // ccc_nand1

module ccc_nand6n (op, nd, in1, in2, in3,
                   in4, in5, in6);
   output op;
   input  nd, in1, in2, in3, in4, in5, in6;
   nand (strong0, pull1) #16 nand1 (op, nd, in1, in2, in3,
                                    in4, in5, in6);
endmodule // ccc_nand6n

module ccc_nand7n (op, nd, in1, in2, in3,
                   in4, in5, in6, in7);
   output op;
   input  nd, in1, in2, in3, in4, in5, in6, in7;
   nand (strong0, pull1) #16 nand1 (op, nd, in1, in2, in3,
                                    in4, in5, in6, in7);
endmodule // ccc_nand6n

module ccc_and1 (nd, in1);
   output nd;
   input  in1;
   buf (pull0, weak1) buf1 (nd, in1);
endmodule // ccc_and1

module ccc_and2 (nd, in1, in2);
   output nd;
   input  in1, in2;
   and (pull0, weak1) #10 and1 (nd, in1, in2);
endmodule // ccc_and1

module ccc_and2a (nd, in1, in2);
   output nd;
   input  in1, in2;
   and (pull0, weak1) #10 and1 (nd, in1, in2);
endmodule // ccc_and2a

module ccc_and3 (nd, in1, in2, in3);
   output nd;
   input  in1, in2, in3;
   and (pull0, weak1) #10 and1 (nd, in1, in2, in3);
endmodule // ccc_and1

module ccc_and4 (nd, in1, in2, in3, in4);
   output nd;
   input  in1, in2, in3, in4;
   and (pull0, weak1) #10 and1 (nd, in1, in2, in3, in4);
endmodule // ccc_and1

module ccc_and5 (nd, in1, in2, in3, in4,
                 in5);
   output nd;
   input  in1, in2, in3, in4, in5;
   and (pull0, weak1) #10 and1 (nd, in1, in2, in3, in4,
                                in5);
endmodule // ccc_and1

//module ccc_and6 (nd, in1, in2, in3, in4,
//                 in5, in6);
//   output nd;
//   input in1, in2, in3, in4, in5, in6;
//   and (pull0, weak1) #10 and1 (nd, in1, in2, in3, in4,
//                            in5, in6);
//endmodule // ccc_and1

//module ccc_and7 (nd, in1, in2, in3, in4,
//                 in5, in6, in6, in7);
//   output nd;
//   input in1, in2, in3, in4, in5, in6, in7;
//   and (pull0, weak1) #10 and1 (nd, in1, in2, in3, in4,
//                            in5, in6, in7);
//endmodule // ccc_and1

//module ccc_and8 (nd, in1, in2, in3, in4,
//                 in5, in6, in6, in7, in8);
//   output nd;
//   input in1, in2, in3, in4, in5, in6, in7, in8;
//   and (pull0, weak1) #10 and1 (nd, in1, in2, in3, in4,
//                            in5, in6, in7, in8);
//endmodule // ccc_and1

module ccc_and9 (nd, in1, in2, in3, in4,
                 in5, in6, in7, in8, in9);
   output nd;
   input  in1, in2, in3, in4, in5, in6, in7, in8, in9;
   and (pull0, weak1) #10 and1 (nd, in1, in2, in3, in4,
                                in5, in6, in7, in8, in9);
endmodule // ccc_and9

module ccc_dla (in, tap1, tap1a, tap2, tap2a, tap3, tap3a,
                tap4, tap4a, tap5, tap5a, tap6, tap6a,
                tap7, tap7a, tap8, tap8a, tap9, tap9a);
   input in;
   output tap1, tap1a, tap2, tap2a, tap3, tap3a,
          tap4, tap4a, tap5, tap5a, tap6, tap6a,
          tap7, tap7a, tap8, tap8a, tap9, tap9a;
   wire   nd1, nd2, nd3, nd4, nd5, nd6, nd7, nd8, nd9;
   buf #8.6 d1 (nd1, in);
   buf #8.6 d2 (nd2, nd1);
   buf #8.6 d3 (nd3, nd2);
   buf #8.6 d4 (nd4, nd3);
   buf #8.6 d5 (nd5, nd4);
   buf #8.6 d6 (nd6, nd5);
   buf #8.6 d7 (nd7, nd6);
   buf #8.6 d8 (nd8, nd7);
   buf #1.7 d9 (nd9, nd8);
   buf (weak0, weak1) t1 (tap1, nd1);
   buf (weak0, weak1) t2 (tap2, nd2);
   buf (weak0, weak1) t3 (tap3, nd3);
   buf (weak0, weak1) t4 (tap4, nd4);
   buf (weak0, weak1) t5 (tap5, nd5);
   buf (weak0, weak1) t6 (tap6, nd6);
   buf (weak0, weak1) t7 (tap7, nd7);
   buf (weak0, weak1) t8 (tap8, nd8);
   buf (weak0, weak1) t9 (tap9, nd9);
   buf (weak0, weak1) t1a (tap1a, nd1);
   buf (weak0, weak1) t2a (tap2a, nd2);
   buf (weak0, weak1) t3a (tap3a, nd3);
   buf (weak0, weak1) t4a (tap4a, nd4);
   buf (weak0, weak1) t5a (tap5a, nd5);
   buf (weak0, weak1) t6a (tap6a, nd6);
   buf (weak0, weak1) t7a (tap7a, nd7);
   buf (weak0, weak1) t8a (tap8a, nd8);
   buf (weak0, weak1) t9a (tap9a, nd9);
endmodule // ccc_dla

module ccc_dlb (in, tap1, tap2, tap3, tap4, tap5, tap6,
                tap7, tap8, tap9, tap10, tap11, tap12,
                tap13, tap14, tap15, tap16, tap17, tap18,
                tap19, tap20, tap21, tap22, tap23, tap24,
                tap25, tap26, tap27, tap28, tap29);
   input in;
   output tap1, tap2, tap3, tap4, tap5, tap6,
          tap7, tap8, tap9, tap10, tap11, tap12,
          tap13, tap14, tap15, tap16, tap17, tap18,
          tap19, tap20, tap21, tap22, tap23, tap24,
          tap25, tap26, tap27, tap28, tap29;
   wire   nd1, nd2, nd3, nd4, nd5, nd6,
          nd7, nd8, nd9, nd10, nd11, nd12,
          nd13, nd14, nd15, nd16, nd17, nd18,
          nd19, nd20, nd21, nd22, nd23, nd24,
          nd25, nd26, nd27, nd28, nd29;
   buf #9.9 d1 (nd1, in);
   buf #9.9 d2 (nd2, nd1);
   buf #9.9 d3 (nd3, nd2);
   buf #9.9 d4 (nd4, nd3);
   buf #9.9 d5 (nd5, nd4);
   buf #9.9 d6 (nd6, nd5);
   buf #9.9 d7 (nd7, nd6);
   buf #9.9 d8 (nd8, nd7);
   buf #9.9 d9 (nd9, nd8);
   buf #9.9 d10 (nd10, nd9);
   buf #9.9 d11 (nd11, nd10);
   buf #9.9 d12 (nd12, nd11);
   buf #9.9 d13 (nd13, nd12);
   buf #9.9 d14 (nd14, nd13);
   buf #9.9 d15 (nd15, nd14);
   buf #9.9 d16 (nd16, nd15);
   buf #9.9 d17 (nd17, nd16);
   buf #9.9 d18 (nd18, nd17);
   buf #9.9 d19 (nd19, nd18);
   buf #9.9 d20 (nd20, nd19);
   buf #9.9 d21 (nd21, nd20);
   buf #9.9 d22 (nd22, nd21);
   buf #9.9 d23 (nd23, nd22);
   buf #9.9 d24 (nd24, nd23);
   buf #9.9 d25 (nd25, nd24);
   buf #9.9 d26 (nd26, nd25);
   buf #9.9 d27 (nd27, nd26);
   buf #9.9 d28 (nd28, nd27);
   buf #9.9 d29 (nd29, nd28);
   buf (weak0, weak1) t1 (tap1, nd1);
   buf (weak0, weak1) t2 (tap2, nd2);
   buf (weak0, weak1) t3 (tap3, nd3);
   buf (weak0, weak1) t4 (tap4, nd4);
   buf (weak0, weak1) t5 (tap5, nd5);
   buf (weak0, weak1) t6 (tap6, nd6);
   buf (weak0, weak1) t7 (tap7, nd7);
   buf (weak0, weak1) t8 (tap8, nd8);
   buf (weak0, weak1) t9 (tap9, nd9);
   buf (weak0, weak1) t10 (tap10, nd10);
   buf (weak0, weak1) t11 (tap11, nd11);
   buf (weak0, weak1) t12 (tap12, nd12);
   buf (weak0, weak1) t13 (tap13, nd13);
   buf (weak0, weak1) t14 (tap14, nd14);
   buf (weak0, weak1) t15 (tap15, nd15);
   buf (weak0, weak1) t16 (tap16, nd16);
   buf (weak0, weak1) t17 (tap17, nd17);
   buf (weak0, weak1) t18 (tap18, nd18);
   buf (weak0, weak1) t19 (tap19, nd19);
   buf (weak0, weak1) t20 (tap20, nd20);
   buf (weak0, weak1) t21 (tap21, nd21);
   buf (weak0, weak1) t22 (tap22, nd22);
   buf (weak0, weak1) t23 (tap23, nd23);
   buf (weak0, weak1) t24 (tap24, nd24);
   buf (weak0, weak1) t25 (tap25, nd25);
   buf (weak0, weak1) t26 (tap26, nd26);
   buf (weak0, weak1) t27 (tap27, nd27);
   buf (weak0, weak1) t28 (tap28, nd28);
   buf (weak0, weak1) t29 (tap29, nd29);
endmodule // ccc_dlb

module ccc_dlc (in, tap1, tap2, tap3, tap4, tap5, tap6,
                tap7, tap8, tap9);
   input in;
   output tap1, tap2, tap3, tap4, tap5, tap6,
          tap7, tap8, tap9;
   wire   nd1, nd2, nd3, nd4, nd5, nd6,
          nd7, nd8, nd9;
   buf #9.9 d1 (nd1, in);
   buf #9.9 d2 (nd2, nd1);
   buf #9.9 d3 (nd3, nd2);
   buf #9.9 d4 (nd4, nd3);
   buf #9.9 d5 (nd5, nd4);
   buf #9.9 d6 (nd6, nd5);
   buf #9.9 d7 (nd7, nd6);
   buf #9.9 d8 (nd8, nd7);
   buf #9.9 d9 (nd9, nd8);
   buf (weak0, weak1) t1 (tap1, nd1);
   buf (weak0, weak1) t2 (tap2, nd2);
   buf (weak0, weak1) t3 (tap3, nd3);
   buf (weak0, weak1) t4 (tap4, nd4);
   buf (weak0, weak1) t5 (tap5, nd5);
   buf (weak0, weak1) t6 (tap6, nd6);
   buf (weak0, weak1) t7 (tap7, nd7);
   buf (weak0, weak1) t8 (tap8, nd8);
   buf (weak0, weak1) t9 (tap9, nd9);
endmodule // ccc_dlc

module ccc_dld (in, tap1, tap4, tap11, tap15, tap18, tap23, tap24);
   input in;
   output tap1, tap4, tap11, tap15, tap18, tap23, tap24;
   wire   nd1, nd2, nd3, nd4, nd5, nd6,
          nd7, nd8, nd9, nd10, nd11, nd12,
          nd13, nd14, nd15, nd16, nd17, nd18,
          nd19, nd20, nd21, nd22, nd23, nd24;
   buf #12 d1 (nd1, in);
   buf #12 d2 (nd2, nd1);
   buf #12 d3 (nd3, nd2);
   buf #12 d4 (nd4, nd3);
   buf #12 d5 (nd5, nd4);
   buf #12 d6 (nd6, nd5);
   buf #12 d7 (nd7, nd6);
   buf #12 d8 (nd8, nd7);
   buf #12 d9 (nd9, nd8);
   buf #12 d10 (nd10, nd9);
   buf #12 d11 (nd11, nd10);
   buf #12 d12 (nd12, nd11);
   buf #12 d13 (nd13, nd12);
   buf #12 d14 (nd14, nd13);
   buf #12 d15 (nd15, nd14);
   buf #12 d16 (nd16, nd15);
   buf #12 d17 (nd17, nd16);
   buf #12 d18 (nd18, nd17);
   buf #12 d19 (nd19, nd18);
   buf #12 d20 (nd20, nd19);
   buf #12 d21 (nd21, nd20);
   buf #12 d22 (nd22, nd21);
   buf #12 d23 (nd23, nd22);
   buf #12 d24 (nd24, nd23);
   buf (weak0, weak1) t1 (tap1, nd1);
   buf (weak0, weak1) t4 (tap4, nd4);
   buf (weak0, weak1) t11 (tap11, nd11);
   buf (weak0, weak1) t15 (tap15, nd15);
   buf (weak0, weak1) t18 (tap18, nd18);
   buf (weak0, weak1) t23 (tap23, nd23);
   buf (weak0, weak1) t24 (tap24, nd24);
endmodule // ccc_dlb

module ccc_dle (in, tap1, tap2, tap8);
   input in;
   output tap1, tap2, tap8;
   wire   nd1, nd2, nd3, nd4, nd5, nd6,
          nd7, nd8;
   buf #12 d1 (nd1, in);
   buf #12 d2 (nd2, nd1);
   buf #12 d3 (nd3, nd2);
   buf #12 d4 (nd4, nd3);
   buf #12 d5 (nd5, nd4);
   buf #12 d6 (nd6, nd5);
   buf #12 d7 (nd7, nd6);
   buf #12 d8 (nd8, nd7);
   buf (weak0, weak1) t1 (tap1, nd1);
   buf (weak0, weak1) t2 (tap2, nd2);
   buf (weak0, weak1) t8 (tap8, nd8);
endmodule // ccc_dle

module ccc_dldrv (op, in1);
   output op;
   input  in1;
   buf (strong0, strong1) #8 buf1 (op, in1);
endmodule // ccc_dldrv

module ccc_ff2223 (ops, opr, ds1, ds2, s1, s2, ck, r1, r2, dr1, dr2, dr3);
   output ops, opr;
   input  ds1, ds2, s1, s2, ck, r1, r2, dr1, dr2, dr3;
   wire   ns1, ns2, ns3, ns4, ns5;
   wire   nr1, nr2, nr3, nr4, nr5;

   //
   // The standard 3C flip-flop design can be tricky to reset
   // properly in Verilog. The issue occurs if all of the set
   // controls signals or all of the reset control signals as
   // well as the clock happen to be high during reset. In this
   // condition the first stage NAND gates propagate the 'x'
   // from the output latch through to nodes ns1 and/or nr1,
   // and this prevents the input latch from resetting in
   // that at least one branch remains at 'x'.
   //
   // Note that this is purely a Verilog modelling issue, if
   // the latches came up holding a '1' or a '0' the flip-flop
   // would reset properly. It's just an issue of the way
   // 'x' is modelled.
   //
   // The "fix" for this is invent an extra input to each of the
   // first stage NAND gates (us1 and ur1) which is held low
   // until reset is over. This is deemed to be until the first
   // time that all of the DC reset and all of the DC set signals
   // achieve logic '1' (and they're not 'x' or 'z'). Once this
   // occurs the reset_kludge_n signal will never return low, so
   // from this point on normal 'x' propagation occurs.
   //
   reg reset_kludge_n = 1'b0;

   always @(ds1 or ds2 or dr1 or dr2 or dr3) begin
      if ((ds1 === 1'b1) && (ds2 === 1'b1) &&
          (dr1 === 1'b1) && (dr2 === 1'b1) &&
          (dr3 === 1'b1) &&
          (nr5 !== 1'bx) && (ns5 !== 1'bx)) begin
         reset_kludge_n = 1'b1;
      end
   end
   
   nand #6 us1 (ns1, ns5, s1, s2, ck, reset_kludge_n);
   nand #6 us2 (ns2, ds1, ds2, ns1, nr2);
   nand #6 us3 (ns3, ns1, ns2);
   nand #6 us4 (ns4, ds1, ds2, ns3, nr4);
   not  #6 us5 (ns5, ns4);
   not  (strong0, pull1) #6 us6 (ops, ns5);
   nand #6 ur1 (nr1, nr5, r1, r2, ck, reset_kludge_n);
   nand #6 ur2 (nr2, dr1, dr2, dr3, nr1, ns2);
   nand #6 ur3 (nr3, nr1, nr2);
   nand #6 ur4 (nr4, dr1, dr2, dr3, nr3, ns4);
   not  #6 ur5 (nr5, nr4);
   not  (strong0, pull1) #6 ur6 (opr, nr5);   
endmodule // ccc_ff1223

module ccc_ff0221 (ops, opr, s1, s2, ck, r1, r2, dr1);
   output ops, opr;
   input  s1, s2, ck, r1, r2, dr1;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(1'b1), .ds2(1'b1),
                  .s1(s1), .s2(s2), .ck(ck), .r1(r1), .r2(r2),
                  .dr1(dr1), .dr2(1'b1), .dr3(1'b1));
endmodule // ccc_ff1003

module ccc_ff0212 (ops, opr, s1, s2, ck, r1, dr1, dr2);
   output ops, opr;
   input  s1, s2, ck, r1, dr1, dr2;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(1'b1), .ds2(1'b1),
                  .s1(s1), .s2(s2), .ck(ck), .r1(r1), .r2(1'b1),
                  .dr1(dr1), .dr2(dr2), .dr3(1'b1));
endmodule // ccc_ff0212

module ccc_ff1002 (ops, opr, ds1, ck, dr1, dr2);
   output ops, opr;
   input  ds1, ck, dr1, dr2;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(1'b1), .s2(1'b1), .ck(ck), .r1(1'b1), .r2(1'b1),
                  .dr1(dr1), .dr2(dr2), .dr3(1'b1));
endmodule // ccc_ff1003

module ccc_ff1002nc (ops, opr, ds1, dr1, dr2);
   output ops, opr;
   input  ds1, dr1, dr2;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(1'b1), .s2(1'b1), .ck(1'b1), .r1(1'b1), .r2(1'b1),
                  .dr1(dr1), .dr2(dr2), .dr3(1'b1));
endmodule // ccc_ff1003

module ccc_ff1003 (ops, opr, ds1, ck, dr1, dr2, dr3);
   output ops, opr;
   input  ds1, ck, dr1, dr2, dr3;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(1'b1), .s2(1'b1), .ck(ck), .r1(1'b1), .r2(1'b1),
                  .dr1(dr1), .dr2(dr2), .dr3(dr3));
endmodule // ccc_ff1003

module ccc_ff1011nc (ops, opr, ds1, r1, dr1);
   output ops, opr;
   input  ds1, r1, dr1;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(1'b1), .s2(1'b1), .ck(1'b1), .r1(r1), .r2(1'b1),
                  .dr1(dr1), .dr2(1'b1), .dr3(1'b1));
endmodule // ccc_ff1003

module ccc_ff1111 (ops, opr, ds1, s1, ck, r1, dr1);
   output ops, opr;
   input  ds1, s1, ck, r1, dr1;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(s1), .s2(1'b1), .ck(ck), .r1(r1), .r2(1'b1),
                  .dr1(dr1), .dr2(1'b1), .dr3(1'b1));
endmodule // ccc_ff1111

module ccc_ff1111nc (ops, opr, ds1, s1, r1, dr1);
   output ops, opr;
   input  ds1, s1, r1, dr1;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(s1), .s2(1'b1), .ck(1'b1), .r1(r1), .r2(1'b1),
                  .dr1(dr1), .dr2(1'b1), .dr3(1'b1));
endmodule // ccc_ff1111

module ccc_ff1112 (ops, opr, ds1, s1, ck, r1, dr1, dr2);
   output ops, opr;
   input  ds1, s1, ck, r1, dr1, dr2;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(s1), .s2(1'b1), .ck(ck), .r1(r1), .r2(1'b1),
                  .dr1(dr1), .dr2(dr2), .dr3(1'b1));
endmodule // ccc_ff1112

module ccc_ff1113 (ops, opr, ds1, s1, ck, r1, dr1, dr2, dr3);
   output ops, opr;
   input  ds1, s1, ck, r1, dr1, dr2, dr3;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(s1), .s2(1'b1), .ck(ck), .r1(r1), .r2(1'b1),
                  .dr1(dr1), .dr2(dr2), .dr3(dr3));
endmodule // ccc_ff1113

module ccc_ff1201 (ops, opr, ds1, s1, s2, ck, dr1);
   output ops, opr;
   input  ds1, s1, s2, ck, dr1;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(s1), .s2(s2), .ck(ck), .r1(1'b1), .r2(1'b1),
                  .dr1(dr1), .dr2(1'b1), .dr3(1'b1));
endmodule // ccc_ff1223

module ccc_ff1212 (ops, opr, ds1, s1, s2, ck, r1, dr1, dr2);
   output ops, opr;
   input  ds1, s1, s2, ck, r1, dr1, dr2;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(s1), .s2(s2), .ck(ck), .r1(r1), .r2(1'b1),
                  .dr1(dr1), .dr2(dr2), .dr3(1'b1));
endmodule // ccc_ff1212

module ccc_ff1222 (ops, opr, ds1, s1, s2, ck, r1, r2, dr1, dr2);
   output ops, opr;
   input  ds1, s1, s2, ck, r1, r2, dr1, dr2;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(s1), .s2(s2), .ck(ck), .r1(r1), .r2(r2),
                  .dr1(dr1), .dr2(dr2), .dr3(1'b1));
endmodule // ccc_ff1222

module ccc_ff1223 (ops, opr, ds1, s1, s2, ck, r1, r2, dr1, dr2, dr3);
   output ops, opr;
   input  ds1, s1, s2, ck, r1, r2, dr1, dr2, dr3;
   ccc_ff2223 ff (.ops(ops), .opr(opr), .ds1(ds1), .ds2(1'b1),
                  .s1(s1), .s2(s2), .ck(ck), .r1(r1), .r2(r2),
                  .dr1(dr1), .dr2(dr2), .dr3(dr3));
endmodule // ccc_ff1223

module ccc_cc057 (ops, opr, dx, dr);
   inout  ops;
   output opr;
   input  dx, dr;

   or  (strong0, pull1) #16 or1  (ops, dx, dr);
   not (strong0, pull1) #16 not1 (opr, ops);
   
endmodule // ccc_cc_057

module ccc_cc074 (op, in1);
   output op;
   input  in1;

   reg    op;
   
   /*
    * For obscure reasons to do with netlisting, actually model
    * a CC074 followed by an inverter, so while CC074 generates
    * inverted pulses, this model generates short-high time pulses
    * for TTYCLK+
    */
   
   parameter BAUD = 110;

   // Upto BAUD = 153600 just about OK in simulation - never achievable in real life...

   localparam TSPS = 1000000000; // Timesteps per second (assume 1ns timescale)
   localparam PULSE = ((BAUD < 76800) ? 1500 : // 1.5 Microseconds is standard in H/W
                       500 );                  // Reduced width for high BAUD rate
   localparam DELAY = 100;       // Half maximum spec of 200ns
   localparam CYCLE = TSPS / (BAUD * 4);
   localparam LOW = CYCLE-PULSE;

   always @(in1) begin
      if (in1 != 0) begin
        //#DELAY;
        op = 1'b0;
      end else begin
         //#DELAY;
         while (!in1) begin
            op = 1'b1;
            #PULSE;
            op = 1'b0;
            #LOW;
         end
      end // else: !if(in1 != 0)
   end // always @ (in1)
  
   
endmodule // ccc_cc074

module ccc_cc344a #(parameter RTC_RATE=5000) (op);
   output op;
   reg op;
   
   localparam TSPS  = 1000000000; // Timesteps per second (assume 1ns timescale)
   localparam CYCLE = TSPS / RTC_RATE;
   localparam HIGH  = CYCLE/2;
   localparam LOW   = CYCLE - HIGH;

   initial begin
      op = 1'b0;
      forever begin
         #LOW;
         op = 1'b1;
         #HIGH;
         op = 1'b0;
      end
   end
   
endmodule // ccc_cc344a

module ccc_cc344b (op, s, r, dr);
   output op;
   input s, r, dr;
   wire opr;
   ccc_ff2223 ff (.ops(op), .opr(opr), .ds1(1'b1), .ds2(1'b1),
                  .s1(s), .s2(1'b1), .ck(1'b1), .r1(r), .r2(1'b1),
                  .dr1(dr), .dr2(1'b1), .dr3(1'b1));
endmodule // ccc_cc344b

module ccc_cc344c (op, s1, s2, r, dr);
   output op;
   input s1, s2, r, dr;
   wire opr;
   ccc_ff2223 ff (.ops(op), .opr(opr), .ds1(1'b1), .ds2(1'b1),
                  .s1(s1), .s2(s2), .ck(1'b1), .r1(r), .r2(1'b1),
                  .dr1(dr), .dr2(1'b1), .dr3(1'b1));
endmodule // ccc_cc344c

module ccc_cc344d (op, s, ck, r, dr);
   output op;
   input s, ck, r, dr;
   wire opr;
   ccc_ff2223 ff (.ops(op), .opr(opr), .ds1(1'b1), .ds2(1'b1),
                  .s1(opr), .s2(s), .ck(ck), .r1(r), .r2(op),
                  .dr1(dr), .dr2(1'b1), .dr3(1'b1));
endmodule // ccc_cc344d

module ccc_cc819a (op, in1, in2, in3, in4);
   output op;
   input in1, in2, in3, in4;
   wire x;
   nand (strong0, pull1) #16 nand1 (op, in1, x);
   nand (strong0, pull1) #16 nand2 (x, op, in2);
   nand (strong0, pull1) #16 nand3 (x, in3, in4);
endmodule // ccc_cc819a

module ccc_cc819 (op, opr, in1, in2, in3, in4);
   output op, opr;
   input in1, in2, in3, in4;
   ccc_cc819a cc819 (.op(op), .in1(in1), .in2(in2), .in3(in3), .in4(in4));
   assign opr = op;
endmodule // ccc_cc819a

module ccc_od335a (op0, op1, op2, op3, op4, op5, op6, op7,
                  in0, in0n, in1, in1n, in2, in2n, inx, iny, inz);

   output op0, op1, op2, op3, op4, op5, op6, op7;
   input in0, in0n, in1, in1n, in2, in2n, inx, iny, inz;

   nand (strong0, pull1) #16 nand0 (op0, in0n, in1n, in2n, inx, iny, inz);
   nand (strong0, pull1) #16 nand1 (op1, in0n, in1n, in2 , inx, iny, inz);
   nand (strong0, pull1) #16 nand2 (op2, in0n, in1 , in2n, inx, iny, inz);
   nand (strong0, pull1) #16 nand3 (op3, in0n, in1 , in2 , inx, iny, inz);
   nand (strong0, pull1) #16 nand4 (op4, in0 , in1n, in2n, inx, iny, inz);
   nand (strong0, pull1) #16 nand5 (op5, in0 , in1n, in2 , inx, iny, inz);
   nand (strong0, pull1) #16 nand6 (op6, in0 , in1 , in2n, inx, iny, inz);
   nand (strong0, pull1) #16 nand7 (op7, in0 , in1 , in2 , inx, iny, inz);
   
endmodule // ccc_od335a

module ccc_dg336a (op, pu, ina1, ina2, ina3, inb1, inb2, inb3,
                   inc1, inc2, inc3, ind1, ind2, ind3);

   output op, pu;
   input ina1, ina2, ina3, inb1, inb2, inb3,
         inc1, inc2, inc3, ind1, ind2, ind3;

   pullup pu1 (pu);
   nand (strong0, highz1) #16 nanda (op, ina1, ina2, ina3);
   nand (strong0, highz1) #16 nandb (op, inb1, inb2, inb3);
   nand (strong0, highz1) #16 nandc (op, inc1, inc2, inc3);
   nand (strong0, highz1) #16 nandd (op, ind1, ind2, ind3);
   
endmodule

module ccc_dg336b (op, pu, ina1, ina2, ina3, ina4, inb1, inb2, inb3, inb4,
                   inc1, inc2, inc3, inc4, ind1, ind2, ind3, ind4);
   
   output op, pu;
   input ina1, ina2, ina3, ina4, inb1, inb2, inb3, inb4,
         inc1, inc2, inc3, inc4, ind1, ind2, ind3, ind4;

   pullup pu1 (pu);
   nand (strong0, highz1) #16 nanda (op, ina1, ina2, ina3, ina4);
   nand (strong0, highz1) #16 nandb (op, inb1, inb2, inb3, inb4);
   nand (strong0, highz1) #16 nandc (op, inc1, inc2, inc3, inc4);
   nand (strong0, highz1) #16 nandd (op, ind1, ind2, ind3, ind4);
   
endmodule
 
module ccc_dg335 (op, pu, ina1, ina2, inb1, inb2, inc1, inc2);

   output op, pu;
   input ina1, ina2, inb1, inb2, inc1, inc2;
   
   pullup pu1 (pu);
   nand (strong0, highz1) #16 nanda (op, ina1, ina2);
   nand (strong0, highz1) #16 nandb (op, inb1, inb2);
   nand (strong0, highz1) #16 nandc (op, inc1, inc2);
   
endmodule

module ccc_cc044 (pu1, on1, oq1, op1, pu2, on2, oq2, op2,
                  pu3, on3, oq3, op3, pu4, on4, oq4, op4,
                  opx, onx, sa1, sb1, gs, sa2, sb2,
                  gp, sa3, sb3, dr, sa4, sb4, ga, gb);

   output pu1, on1, oq1, op1, pu2, on2, oq2, op2,
          pu3, on3, oq3, op3, pu4, on4, oq4, op4,
          opx, onx;
   input sa1, sb1, gs, sa2, sb2,
         gp, sa3, sb3, dr, sa4, sb4, ga, gb;

   wire n1, n2, n3, n4;

   nand (strong0, pull1)  #16 nand11 (n1,  sa1, gs, sb1);
   nand (strong0, pull1)  #16 nand12 (oq1, n1);
   nand (strong0, pull1)  #16 nand13 (n1,  oq1, dr);
   pullup                       pu11 (pu1);
   nand (strong0, highz1) #16 nand14 (on1, oq1, ga, gb);
   nand (strong0, pull1)  #16 nand15 (op1, oq1, ga, gb, gp);
   
   nand (strong0, pull1)  #16 nand21 (n2,  sa2, gs, sb2);
   nand (strong0, pull1)  #16 nand22 (oq2, n2);
   nand (strong0, pull1)  #16 nand23 (n2,  oq2, dr);
   pullup                       pu21 (pu2);
   nand (strong0, highz1) #16 nand24 (on2, oq2, ga, gb,     n1);
   nand (strong0, pull1)  #16 nand25 (op2, oq2, ga, gb, gp, n1);
   
   nand (strong0, pull1)  #16 nand31 (n3,  sa3, gs, sb3);
   nand (strong0, pull1)  #16 nand32 (oq3, n3);
   nand (strong0, pull1)  #16 nand33 (n3,  oq3, dr);
   pullup                       pu31 (pu3);
   nand (strong0, highz1) #16 nand34 (on3, oq3, ga, gb,     n1, n2);
   nand (strong0, pull1)  #16 nand35 (op3, oq3, ga, gb, gp, n1, n2);
   
   nand (strong0, pull1)  #16 nand41 (n4,  sa4, gs, sb4);
   nand (strong0, pull1)  #16 nand42 (oq4, n4);
   nand (strong0, pull1)  #16 nand43 (n4,  oq4, dr);
   pullup                       pu41 (pu4);
   nand (strong0, highz1) #16 nand44 (on4, oq4, ga, gb,     n1, n2, n3);
   nand (strong0, pull1)  #16 nand45 (op4, oq4, ga, gb, gp, n1, n2, n3);

   nand (strong0, pull1)  #16 nandx1 (onx, gb, ga, n4, n1, n2, n3);
   nand (strong0, pull1)  #16 nandx2 (opx, onx);
   
endmodule // ccc_cc044

module ccc_cc091 (opa, ona, opb, onb, opc, onc, opd, ond,
                  ope, one, opf, onf, opg, ong, oph, onh, 
                  count, dsa, dsb, dsc, dsd, dse, dsf, dsg, dsh,
                  r, binb, binc, bcdnd, binf, bing, bcdnh);

   output opa, ona, opb, onb, opc, onc, opd, ond,
          ope, one, opf, onf, opg, ong, oph, onh;
   inout dsa, dsb, dsc, dsd, dse, dsf, dsg, dsh;
   input count, r, binb, binc, bcdnd, binf, bing, bcdnh;

   wire qb, qf;
   
   pullup pua (dsa);
   pullup pub (dsb);
   pullup puc (dsc);
   pullup pud (dsd);
   pullup pue (dse);
   pullup puf (dsf);
   pullup pug (dsg);
   pullup puh (dsh);

   ccc_ff2223 ffa (.ops(opa),  .opr(ona), .ds1(dsa),  .ds2(1'b1), .s1(1'b1),  .s2(1'b1),
                   .ck(count), .r1(1'b1), .r2(1'b1),  .dr1(1'b1), .dr2(1'b1), .dr3(r));
   ccc_ff2223 ffb (.ops( qb),  .opr(onb), .ds1(dsb),  .ds2(1'b1), .s1(bcdnd), .s2(opa),
                   .ck(count), .r1(opa),  .r2(bcdnd), .dr1(1'b1), .dr2(1'b1), .dr3(r));
   // Delay opb so, when it arrives at s/r inputs of ffd, it is after the clock (opa)
   buf #16 del_opb (opb, qb);
   ccc_ff2223 ffc (.ops(opc),  .opr(onc), .ds1(dsc),  .ds2(1'b1), .s1(1'b1),  .s2(1'b1),
                   .ck(opb),   .r1(1'b1), .r2(1'b1),  .dr1(1'b1), .dr2(1'b1), .dr3(r));
   ccc_ff2223 ffd (.ops(opd),  .opr(ond), .ds1(dsd),  .ds2(1'b1), .s1(opc),   .s2(opb),
                   .ck(opa),   .r1(binb), .r2(binc),  .dr1(1'b1), .dr2(1'b1), .dr3(r));

   ccc_ff2223 ffe (.ops(ope),  .opr(one), .ds1(dse),  .ds2(1'b1), .s1(1'b1),  .s2(1'b1),
                   .ck(opd),   .r1(1'b1), .r2(1'b1),  .dr1(1'b1), .dr2(1'b1), .dr3(r));
   ccc_ff2223 fff (.ops( qf),  .opr(onf), .ds1(dsf),  .ds2(1'b1), .s1(bcdnh), .s2(ope),
                   .ck(opd),   .r1(ope),  .r2(bcdnh), .dr1(1'b1), .dr2(1'b1), .dr3(r));
   buf #16 del_opf (opf, qf);
   ccc_ff2223 ffg (.ops(opg),  .opr(ong), .ds1(dsg),  .ds2(1'b1), .s1(1'b1),  .s2(1'b1),
                   .ck(opf),   .r1(1'b1), .r2(1'b1),  .dr1(1'b1), .dr2(1'b1), .dr3(r));
   ccc_ff2223 ffh (.ops(oph),  .opr(onh), .ds1(dsh),  .ds2(1'b1), .s1(opf),   .s2(opg),
                   .ck(ope),   .r1(binf), .r2(bing),  .dr1(1'b1), .dr2(1'b1), .dr3(r));
  
endmodule // ccc_cc091
