/***********************************************************************
 *
 * h316 - H316 ASR interface
 * 
 * Copyright (C) 2012 Adrian Wise
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of version 3 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See http://www.series16.adrianwise.co.uk
 *   mailto:apw@adrianwise.co.uk
 * 
 ***********************************************************************
 * 
 * This is a wrapper around the gate-level netlist combining the
 * input and output buses into verilog buses.
 * 
 **********************************************************************/
module h316_asr_bus (/*AUTOARG*/
   // Outputs
   INBxx_n, DRLIN_n, PIL00_n,
   // Inouts
   TYSIG_n,
   // Inputs
   ADBxx_n, OTBxx_p, CMKXX_n, MSTCL_n, OCPLS_n, RRLIN_n, SMK01_n,
   SMKXX_n
   );
   
   input [7:16] ADBxx_n;
   input [9:16] OTBxx_p;
   
   input        CMKXX_n;
   input        MSTCL_n;
   input        OCPLS_n;
   input        RRLIN_n;
   input        SMK01_n;
   input        SMKXX_n;
   
   inout        TYSIG_n;
   
   output [9:16] INBxx_n;
   output        DRLIN_n;
   output        PIL00_n;
   
   h316_asr asr (// Outputs
                 .DRLIN_n               (DRLIN_n),
                 .INB09_n               (INBxx_n[09]),
                 .INB10_n               (INBxx_n[10]),
                 .INB11_n               (INBxx_n[11]),
                 .INB12_n               (INBxx_n[12]),
                 .INB13_n               (INBxx_n[13]),
                 .INB14_n               (INBxx_n[14]),
                 .INB15_n               (INBxx_n[15]),
                 .INB16_n               (INBxx_n[16]),
                 .PIL00_n               (PIL00_n),
                 // Inouts
                 .TYSIG_n               (TYSIG_n),
                 // Inputs
                 .ADB07_n               (ADBxx_n[07]),
                 .ADB08_n               (ADBxx_n[08]),
                 .ADB09_n               (ADBxx_n[09]),
                 .ADB10_n               (ADBxx_n[10]),
                 .ADB11_n               (ADBxx_n[11]),
                 .ADB12_n               (ADBxx_n[12]),
                 .ADB13_n               (ADBxx_n[13]),
                 .ADB14_n               (ADBxx_n[14]),
                 .ADB15_n               (ADBxx_n[15]),
                 .ADB16_n               (ADBxx_n[16]),
                 .CMKXX_n               (CMKXX_n),
                 .MSTCL_n               (MSTCL_n),
                 .OCPLS_n               (OCPLS_n),
                 .OTB09_p               (OTBxx_p[09]),
                 .OTB10_p               (OTBxx_p[10]),
                 .OTB11_p               (OTBxx_p[11]),
                 .OTB12_p               (OTBxx_p[12]),
                 .OTB13_p               (OTBxx_p[13]),
                 .OTB14_p               (OTBxx_p[14]),
                 .OTB15_p               (OTBxx_p[15]),
                 .OTB16_p               (OTBxx_p[16]),
                 .RRLIN_n               (RRLIN_n),
                 .SMK01_n               (SMK01_n),
                 .SMKXX_n               (SMKXX_n));

endmodule // h316_asr_bus
