*    TEST MEMORY LOCKOUT OPTION
\ABS
\ORG\'1000
************************************************************
*
*    I/O DEVICE ADDRESSES FOR VSIM DEVICE
*
VSIM\EQU\'35\DEVICE ADDRESS
*
EXIT\EQU\VSIM\EXIT CODE
************************************************************
*
*    SECTOR ZERO VARIABLES
*
\SETB\'100
\ORG\'200
TMP1\BSS\1
TMP2\BSS\1
************************************************************
*
*    FIXED SECTOR ZERO LOCATIONS
*
\ORG\'777
TNUM\OCT\0\TEST NUMBER
************************************************************
*
*    START OF TEST PROGRAM
*
STRT\JST\INIT
\JST\TST1\RESTRICTED MODE
\JST\TST2\INDIRECTION LIMIT
\JST\TST3\MEMORY PROTECTION
* TODO:
*    PROTECTED SECTORS
*    BASE SECTOR RELOCATION
*
\CRA\\ZERO EXIT CODE
\STA\TNUM\CLEAR TEST NUMBER
*
\OTA\EXIT
\JMP\*-1
*
\HLT\\DON'T EXPECT TO REACH HERE
\EJCT
************************************************************
*
*    TEST 1 - RESTRICTED MODE
*
TST1\DAC\**
\LDA\=1\TEST NUMBER
\STA\TNUM
*
\CRA
\SMK\'1320\BASE SECTOR NOT RELOCATED
\CMA\\ALL-ONES
\SMK\'1420\ENABLE ALL SECTORS
\SMK\'1520
\SMK\'1620
\SMK\'1720
*
*    BASIC CHECKS, HLT SHOULD VIOLATE, NOP SHOULD NOT
*
\JST\XMLO\CHECK HLT CAUSES VIOLATION
\HLT\\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JST\NMLO\CHECK NOP DOESN'T VIOLATE
\NOP\\INSTRUCTION TO TEST
\NOP
\NOP
\LDA\MLOO\SHOULD BE ZERO
\SZE
\HLT\\ERROR - MLO SHOULD NOT HAVE OCCURRED
*
*   TEST OTHERS THAT SHOULD ALWAYS VIOLATE
*
\JST\XMLO\CHECK INH CAUSES VIOLATION
\INH\\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JST\XMLO\CHECK INA CAUSES VIOLATION
\INA\'4\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JST\XMLO\CHECK OTA CAUSES VIOLATION
\OTA\'4\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JST\XMLO\CHECK SKS CAUSES VIOLATION
\SKS\'4\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JST\XMLO\CHECK OCP CAUSES VIOLATION
\OCP\'4\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JST\XMLO\CHECK SMK CAUSES VIOLATION
\CRA
\SMK\'20\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JST\XMLO\CHECK OTK CAUSES VIOLATION
\CRA
\OTK\\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JMP*\TST1
\EJCT
************************************************************
*
*    TEST 2 - WHEN DOES INDIRECTION CAUSE VIOLATION?
*
TST2\DAC\**
\LDA\=2\TEST NUMBER
\STA\TNUM
*
\CRA
\STA\INDT
*
\JST\NMLO\CHECK 7 LEVELS DOESN'T VIOLATE
\LDA*\IND6\THIS INDIRECT PLUS SIX MORE
\NOP
\NOP
\LDA\MLOO\SHOULD BE ZERO
\SZE
\HLT\\ERROR - MLO SHOULD NOT HAVE OCCURRED
*
\JST\XMLO\CHECK 8 LEVELS CAUSES VIOLATION
\LDA*\IND7\THIS INDIRECT PLUS SEVEN MORE
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JMP*\TST2
************************************************************
*
*    TEST MEMORY PROTECTION
*
TST3\DAC\**
\LDA\=3\TEST NUMBER
\STA\TNUM
*
\LDA\='07777\TOP BIT CLEAR
\SMK\'1420\PROTECT SECTOR ZERO
*
\LDX\=-1\SET STORE TARGET
\CRA\\TRY TO STORE ZERO
\JST\XMLO\CHECK STA CAUSES VIOLATION
\STA\0\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
\IRS\0\SHOULD SKIP
\HLT\\ERROR - STORE SUCCEEDED
*
\JST\NMLO\CHECK LDA DOESN'T VIOLATE
\LDA\0\INSTRUCTION TO TEST
\NOP
\NOP
\LDA\MLOO\SHOULD BE ZERO
\SZE
\HLT\\ERROR - MLO SHOULD NOT HAVE OCCURRED
*
*    CHECK OTHER INSTRUCTIONS THAT STORE
*
\JST\LRMD\LEAVE RESTRICTED MODE
\LDX\=-1\SET STORE TARGET
\JST\XMLO\CHECK LDX CAUSES VIOLATION
\LDX\=1\INSTRUCTION TO TEST
\NOP\\NOTE LDX WRITES TO [0]
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
\IRS\0\SHOULD SKIP
\HLT\\ERROR - LDX WROTE [0]
*
\LDA\=-1
\STA\'20\SET STORE TARGET
\LDX\=0\TRY TO STORE ZERO
\JST\XMLO\CHECK STX CAUSES VIOLATION
\STX\'20\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
\IRS\'20\SHOULD SKIP
\HLT\\ERROR - STX WROTE ['20]
*
\LDA\=-1
\STA\'20\SET STORE TARGET
\CRA\\TRY TO STORE ZERO
\JST\XMLO\CHECK IMA CAUSES VIOLATION
\IMA\'20\INSTRUCTION TO TEST
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
\IRS\'20\SHOULD SKIP
\HLT\\ERROR - IMA WROTE ['20]
*
\LDA\=-1
\STA\'20\SET STORE TARGET
\JST\XMLO\CHECK IRS CAUSES VIOLATION
\IRS\'20\INSTRUCTION TO TEST
\NOP\\SHOULD BE SKIPPED
\NOP
\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
\IRS\'20\SHOULD SKIP
\HLT\\ERROR - IRS WROTE ['20]
*
\LDA\DJST\SET UP RETURN ADDRESS AS
\STA\'20\IF JST SUCCEEDED
\LDA\LNOP\PICK UP NOP INSTRUCTION
\STA\'21\BUILD TRIVIAL SUBROUTINE
\STA\'22\AT JST TARGET
\LDA\XRET
\STA\'23
\JST\XMLO\CHECK IRS CAUSES VIOLATION
\JST\'20\INSTRUCTION TO TEST
XJST\NOP
LNOP\NOP
\IRS\MLOO\SHOULD SKIP
\HLT\\ERROR - NO MLO WHEN EXPECTED
*
\JMP*\TST3
*
DJST\DAC\XJST
XRET\JMP*\'20
*
IND7\DAC*\IND6
IND6\DAC*\IND5
IND5\DAC*\IND4
IND4\DAC*\IND3
IND3\DAC*\IND2
IND2\DAC*\IND1
IND1\DAC*\INDT
INDT\BSS\1\INDIRECTION TARGET
*
\EJCT
************************************************************
*
*    SET-UP FOR MLO NOT EXPECTED
*
NMLO\DAC\**\NO MEMORY LOCKOUT VIOLATION EXPECTED
\LDA\=2\FLAG TO HANDLER THAT INH MAY OCCUR
\STA\TMLO\SAVE A
\STA\XPCT
\INH\\POSSIBLY CAUSING MLO VIOLATION
\NOP\\ENSURE FOLLOWING OCCURS AFTER
\NOP\\RETURN FROM HANDLER
NML1\CRA
\STA\XPCT\TELL HANDLER NO VIOLATION EXPECTED
\STA\MLOO\NO MLO OCCURRED (YET)
\LDA\NMLO\GET RETURN ADDRESS
\STA\XINA\STORE (UN)EXPECTED INSTRUCTION ADDRESS
\LDA\DMLH\ADDRESS OF HANDLER
\STA\'62
\LDA\TMLO\RESTORE A
\ERM\\ENTER RESTRICTED MODE
\JMP*\NMLO
DML1\DAC\NML1
*
************************************************************
*
*    SET-UP FOR MLO EXPECTED
*
XMLO\DAC\**\EXPECT MEMORY LOCKOUT VIOLATION
\STA\TMLO\SAVE A
\LDA\=1
\STA\XPCT\TELL HANDLER A VIOLATION EXPECTED
\CRA
\STA\MLOO\NO MLO OCCURRED (YET)
\LDA\XMLO\GET RETURN ADDRESS
XML1\STA\XINA\STORE EXPECTED INSTRUCTION ADDRESS
*
\LDA\DMLH\ADDRESS OF HANDLER
\STA\'62\STORE IN VECTOR
*
\LDA\TMLO\RESTORE A
\ERM\\ENTER RESTRICTED MODE
\JMP*\XMLO\RETURN
*
XINA\BSS\1
XPCT\BSS\1
MLOO\BSS\1\MLO OCCURRED (SET TO -1)
TMLO\BSS\1\TEMP used in XMLO & NMLO
\EJCT
************************************************************
*
*    MEMORY LOCKOUT VIOLATION HANDLER
*
DMLH\DAC\MLOH
MLOH\DAC\**\MLO VIOLATION HANDLER
\STA\HNDA
\LDA\XPCT\GET THE EXPECTED FLAG
\CAS\=1
\JMP\IMDX\>1 - EXIT IMMEDIATELY
\SNZ\\=1 - WAS EXPECTED
\HLT\\<1 - UNEXPECTED, SO SULK
\LDA\=-1\FLAG MLO OCCURRED
\STA\MLOO
*
\LDA\HNDA\RECOVER A-REG
\JMP*\MLOH\RETURN FROM HANDLER
*
IMDX\LDA\HNDA\IMMEDIATE EXIT TO NML1
\JMP\NML1
*
HNDA\BSS\1\HANDLER STORES A-REG HERE
************************************************************
*
*    LEAVE RESTRICTED MODE
*
LRMD\DAC\**
\JST\XMLO\EXPECT AN MLO VIOLATION
\INH\\DELIBERATE VIOLATION
\NOP
\NOP
\JMP*\LRMD
\EJCT
************************************************************
*
*    INITIALISATION CODE
*
INIT\DAC\**
\LDA\MESS\PRINT START-UP MESSAGE
\JST\TYPE
\JMP*\INIT
*
************************************************************
*
*    GENERAL TYPE ROUTINE
*
TYPE\DAC\**\TYPE ROUT
\STA\TMP1\SAVE MSG ADRS
\LDA*\TMP1\GET WORD COUNT
\STA\TMP2\
\SKS\'104\TEST FOR ASR BUSY
\JMP\*-1
\OCP\'104\ENABLE, OUTPUT MODE
PRCH\IRS\TMP1\BUMP ADDR FOR NEXT WORD OF MSG.
\LDA*\TMP1
\ALR\8
\OTA\'4\OUTPUT 1-8 IN ASCII
\JMP\*-1
\LDA*\TMP1
\OTA\'4\OUTPUT 9-16
\JMP\*-1
\IRS\TMP2\SKIP AFTER LAST WORD
\JMP\PRCH\PRINT NEXT WORD
\JMP*\TYPE
************************************************************
*
*   START-UP MESSAGE
*
MESS\DAC\*+1
\DEC\-19\SET TO -VE (BCI-COUNT + 3)
\OCT\106612,106612
*\  \   11223344556677889900112233445566
\BCI\16,MLO TEST, 19 NOVEMBER 2017 REV A 
\OCT\106612
*
\END
$
************************************************************
* XEMACS LOCAL VARIABLES
*
* LOCAL VARIABLES:
* MODE: FUNDAMENTAL
* END:
